/*
 * Copyright (C) 2006 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package android.util;

/**
 * Base class for all unchecked exceptions thrown by the Android frameworks.
 */
public class AndroidRuntimeException extends RuntimeException {
	public AndroidRuntimeException() {
	}

	public AndroidRuntimeException(String name) {
		super(name);
	}

	public AndroidRuntimeException(String name, Throwable cause) {
		super(name, cause);
	}

	public AndroidRuntimeException(Exception cause) {
		super(cause);
	}
};
